Index: squid/src/authenticate.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/authenticate.c,v
retrieving revision 1.1.1.3.12.17.2.23
retrieving revision 1.1.1.3.12.17.2.24
diff -u -r1.1.1.3.12.17.2.23 -r1.1.1.3.12.17.2.24
--- squid/src/authenticate.c	6 Jan 2001 13:31:53 -0000	1.1.1.3.12.17.2.23
+++ squid/src/authenticate.c	7 Jan 2001 09:48:30 -0000	1.1.1.3.12.17.2.24
@@ -436,156 +442,159 @@
 /* send the auth types we are configured to support (and have compiled in!) */
 {
 /*    auth_type_t auth_type=err->auth_type;
-    auth_state_t auth_state=err->auth_state;
-    char *authchallenge=err->authchallenge;
-*/  auth_user_request_t *auth_user_request=err->auth_user_request;
+ * auth_state_t auth_state=err->auth_state;
+ * char *authchallenge=err->authchallenge;
+ */ auth_user_request_t *auth_user_request = err->auth_user_request;
     int type;
     switch (err->http_status) {
     case HTTP_PROXY_AUTHENTICATION_REQUIRED:
-         /* Proxy authorisation needed */
-         type= HDR_PROXY_AUTHENTICATE;
-     break;
-     case HTTP_UNAUTHORIZED:
-         /* WWW Authorisation needed */
-         type=HDR_WWW_AUTHENTICATE;
-     break;
-     default:
-         /* Keep GCC happy */
-         /* some other HTTP status */
+	/* Proxy authorisation needed */
+	type = HDR_PROXY_AUTHENTICATE;
+	break;
+    case HTTP_UNAUTHORIZED:
+	/* WWW Authorisation needed */
+	type = HDR_WWW_AUTHENTICATE;
+	break;
+    default:
+	/* Keep GCC happy */
+	/* some other HTTP status */
 	return;
-     break;
-     }
-    debug(29,9)("authenticateFixHeader: headertype:%d authuser:%d\n",type,auth_user_request);
-    if ((auth_user_request !=NULL) && (auth_user_request->auth_user->auth_module>0))
-        authscheme_list[auth_user_request->auth_user->auth_module-1].authFixHeader(auth_user_request, rep, type, err->request);
+	break;
+    }
+    debug(29, 9) ("authenticateFixHeader: headertype:%d authuser:%d\n", type, auth_user_request);
+    if ((auth_user_request != NULL) && (auth_user_request->auth_user->auth_module > 0))
+	authscheme_list[auth_user_request->auth_user->auth_module - 1].authFixHeader(auth_user_request, rep, type, err->request);
     else {
-        int i;
-        authScheme *scheme;
-        /* call each configured authscheme */
-        for (i = 0; i < Config.authConfig.n_configured; i++)
-        {
-            scheme=Config.authConfig.schemes+i;
-            if (authscheme_list[scheme->Id].Active())
-                authscheme_list[scheme->Id].authFixHeader(auth_user_request,rep,type, 
-                    err->request);
-            else
-                debug(29,8)("authenticateFixHeader: Configured scheme %s not Active\n",scheme->typestr);
-        }
+	int i;
+	authScheme *scheme;
+	/* call each configured authscheme */
+	for (i = 0; i < Config.authConfig.n_configured; i++) {
+	    scheme = Config.authConfig.schemes + i;
+	    if (authscheme_list[scheme->Id].Active())
+		authscheme_list[scheme->Id].authFixHeader(auth_user_request, rep, type,
+		    err->request);
+	    else
+		debug(29, 8) ("authenticateFixHeader: Configured scheme %s not Active\n", scheme->typestr);
+	}
     }
 }
 #endif
 
 void
-authenticateFixHeader(HttpReply * rep, auth_user_request_t * auth_user_request, request_t* request, int accelerated)
+authenticateFixHeader(HttpReply * rep, auth_user_request_t * auth_user_request, request_t * request, int accelerated)
 /* send the auth types we are configured to support (and have compiled in!) */
 {
 /*    auth_type_t auth_type=err->auth_type;
-    auth_state_t auth_state=err->auth_state;
-    char *authchallenge=err->authchallenge;
-  auth_user_request_t *auth_user_request=err->auth_user_request;
-*/
-    int type=0;
+ * auth_state_t auth_state=err->auth_state;
+ * char *authchallenge=err->authchallenge;
+ * auth_user_request_t *auth_user_request=err->auth_user_request;
+ */
+    int type = 0;
     switch (rep->sline.status) {
     case HTTP_PROXY_AUTHENTICATION_REQUIRED:
-         /* Proxy authorisation needed */
-         type= HDR_PROXY_AUTHENTICATE;
-    break;
+	/* Proxy authorisation needed */
+	type = HDR_PROXY_AUTHENTICATE;
+	break;
     case HTTP_UNAUTHORIZED:
-         /* WWW Authorisation needed */
-         type=HDR_WWW_AUTHENTICATE;
-    break;
+	/* WWW Authorisation needed */
+	type = HDR_WWW_AUTHENTICATE;
+	break;
     default:
-         /* Keep GCC happy */
-         /* some other HTTP status */
-    break;
-    }
-    debug(29,9)("authenticateFixHeader: headertype:%d authuser:%d\n",type,auth_user_request);
-    if ((rep->sline.status==HTTP_PROXY_AUTHENTICATION_REQUIRED) 
-        || (rep->sline.status==HTTP_UNAUTHORIZED))
-    /* this is a authenticate-needed response */
+	/* Keep GCC happy */
+	/* some other HTTP status */
+	break;
+    }
+    debug(29, 9) ("authenticateFixHeader: headertype:%d authuser:%d\n", type, auth_user_request);
+    if ((rep->sline.status == HTTP_PROXY_AUTHENTICATION_REQUIRED)
+	|| (rep->sline.status == HTTP_UNAUTHORIZED))
+	/* this is a authenticate-needed response */
     {
-        if ((auth_user_request !=NULL) && (auth_user_request->auth_user->auth_module>0))
-            authscheme_list[auth_user_request->auth_user->auth_module-1].authFixHeader(auth_user_request, rep, type, request);
-        else {
-            int i;
-            authScheme *scheme;
-            /* call each configured authscheme */
-            for (i = 0; i < Config.authConfig.n_configured; i++)
-            {
-                scheme=Config.authConfig.schemes+i;
-                if (authscheme_list[scheme->Id].Active())
-                    authscheme_list[scheme->Id].authFixHeader(auth_user_request,rep,type,
-                        request);
-                else
-                    debug(29,4)("authenticateFixHeader: Configured scheme %s not Active\n",scheme->typestr);
-            }
-        }
-    }
-    if ((auth_user_request != NULL) && (auth_user_request->auth_user->auth_module>0)
-        && (authscheme_list[auth_user_request->auth_user->auth_module-1].AddHeader))
-        authscheme_list[auth_user_request->auth_user->auth_module-1].AddHeader(auth_user_request, rep, accelerated);
+	if ((auth_user_request != NULL) && (auth_user_request->auth_user->auth_module > 0))
+	    authscheme_list[auth_user_request->auth_user->auth_module - 1].authFixHeader(auth_user_request, rep, type, request);
+	else {
+	    int i;
+	    authScheme *scheme;
+	    /* call each configured authscheme */
+	    for (i = 0; i < Config.authConfig.n_configured; i++) {
+		scheme = Config.authConfig.schemes + i;
+		if (authscheme_list[scheme->Id].Active())
+		    authscheme_list[scheme->Id].authFixHeader(auth_user_request, rep, type,
+			request);
+		else
+		    debug(29, 4) ("authenticateFixHeader: Configured scheme %s not Active\n", scheme->typestr);
+	    }
+	}
+    }
+    if ((auth_user_request != NULL) && (auth_user_request->auth_user->auth_module > 0)
+	&& (authscheme_list[auth_user_request->auth_user->auth_module - 1].AddHeader))
+	authscheme_list[auth_user_request->auth_user->auth_module - 1].AddHeader(auth_user_request, rep, accelerated);
 }
 
 /* call the active auth module and allow it to add a trailer to the request */
 void
-authenticateAddTrailer(HttpReply * rep, auth_user_request_t * auth_user_request, request_t* request, int accelerated)
+authenticateAddTrailer(HttpReply * rep, auth_user_request_t * auth_user_request, request_t * request, int accelerated)
 {
-    if ((auth_user_request != NULL) && (auth_user_request->auth_user->auth_module>0)
-        && (authscheme_list[auth_user_request->auth_user->auth_module-1].AddTrailer))
-        authscheme_list[auth_user_request->auth_user->auth_module-1].AddTrailer(auth_user_request, rep, accelerated);
+    if ((auth_user_request != NULL) && (auth_user_request->auth_user->auth_module > 0)
+	&& (authscheme_list[auth_user_request->auth_user->auth_module - 1].AddTrailer))
+	authscheme_list[auth_user_request->auth_user->auth_module - 1].AddTrailer(auth_user_request, rep, accelerated);
 }
 
-void authenticateAuthUserLock(auth_user_t *auth_user)
+void
+authenticateAuthUserLock(auth_user_t * auth_user)
 {
-   debug (29,9) ("authenticateAuthUserLock auth_user '%d'.\n",auth_user);
-   assert(auth_user!=NULL);
-   auth_user->references++;
-   debug (29,9) ("authenticateAuthUserLock auth_user '%d' now at '%d'.\n",auth_user, auth_user->references);
+    debug(29, 9) ("authenticateAuthUserLock auth_user '%d'.\n", auth_user);
+    assert(auth_user != NULL);
+    auth_user->references++;
+    debug(29, 9) ("authenticateAuthUserLock auth_user '%d' now at '%d'.\n", auth_user, auth_user->references);
 }
 
-void authenticateAuthUserUnlock(auth_user_t *auth_user)
+void
+authenticateAuthUserUnlock(auth_user_t * auth_user)
 {
-    debug (29,9) ("authenticateAuthUserUnlock auth_user '%d'.\n",auth_user);
-    assert(auth_user!=NULL);
-    if (auth_user->references>0){
-        auth_user->references--;
+    debug(29, 9) ("authenticateAuthUserUnlock auth_user '%d'.\n", auth_user);
+    assert(auth_user != NULL);
+    if (auth_user->references > 0) {
+	auth_user->references--;
     } else {
-        debug(29,1) ("Attempt to lower Auth User %d refcount below 0!\n",auth_user);
+	debug(29, 1) ("Attempt to lower Auth User %d refcount below 0!\n", auth_user);
     }
-    debug (29,9) ("authenticateAuthUserUnlock auth_user '%d' now at '%d'.\n",auth_user, auth_user->references);
-    if (auth_user->references==0) 
-        authenticateFreeProxyAuthUser(auth_user);
+    debug(29, 9) ("authenticateAuthUserUnlock auth_user '%d' now at '%d'.\n", auth_user, auth_user->references);
+    if (auth_user->references == 0)
+	authenticateFreeProxyAuthUser(auth_user);
 }
 
-void authenticateAuthUserRequestLock(auth_user_request_t *auth_user_request)
+void
+authenticateAuthUserRequestLock(auth_user_request_t * auth_user_request)
 {
-   debug (29,9) ("authenticateAuthUserRequestLock auth_user request '%d'.\n",auth_user_request);
-   assert(auth_user_request!=NULL);
-   auth_user_request->references++;
-   debug (29,9) ("authenticateAuthUserRequestLock auth_user request '%d' now at '%d'.\n",auth_user_request, auth_user_request->references);
+    debug(29, 9) ("authenticateAuthUserRequestLock auth_user request '%d'.\n", auth_user_request);
+    assert(auth_user_request != NULL);
+    auth_user_request->references++;
+    debug(29, 9) ("authenticateAuthUserRequestLock auth_user request '%d' now at '%d'.\n", auth_user_request, auth_user_request->references);
 }
 
-void authenticateAuthUserRequestUnlock(auth_user_request_t *auth_user_request)
+void
+authenticateAuthUserRequestUnlock(auth_user_request_t * auth_user_request)
 {
-    debug (29,9) ("authenticateAuthUserRequestUnlock auth_user request '%d'.\n",auth_user_request);
+    debug(29, 9) ("authenticateAuthUserRequestUnlock auth_user request '%d'.\n", auth_user_request);
     assert(auth_user_request != NULL);
-    if (auth_user_request->references>0){
-        auth_user_request->references--;
+    if (auth_user_request->references > 0) {
+	auth_user_request->references--;
     } else {
-        debug(29,1) ("Attempt to lower Auth User request %d refcount below 0!\n",auth_user_request);
+	debug(29, 1) ("Attempt to lower Auth User request %d refcount below 0!\n", auth_user_request);
     }
-    debug (29,9) ("authenticateAuthUserRequestUnlock auth_user_request '%d' now at '%d'.\n",auth_user_request, auth_user_request->references);
-    if (auth_user_request->references==0) {
-        /* not locked anymore */
-        authenticateAuthUserRequestFree(auth_user_request);
+    debug(29, 9) ("authenticateAuthUserRequestUnlock auth_user_request '%d' now at '%d'.\n", auth_user_request, auth_user_request->references);
+    if (auth_user_request->references == 0) {
+	/* not locked anymore */
+	authenticateAuthUserRequestFree(auth_user_request);
     }
 }
 
-int authenticateAuthUserInuse(auth_user_t *auth_user)
+int
+authenticateAuthUserInuse(auth_user_t * auth_user)
 /* returns 0 for not in use */
 {
-   assert(auth_user!=NULL);
-   return auth_user->references;
+    assert(auth_user != NULL);
+    return auth_user->references;
 }
 
 /* Combine two user structs. ONLY to be called from within a scheme module.
@@ -593,25 +602,24 @@
  * without invalidating all the request scheme data. 
  * the scheme is also responsible for merging any user related scheme data itself. */
 void
-authenticateAuthUserMerge(auth_user_t *from, auth_user_t *to)
+authenticateAuthUserMerge(auth_user_t * from, auth_user_t * to)
 {
-    dlink_node * link, *tmplink;
-    auth_user_request_t * auth_user_request;
+    dlink_node *link, *tmplink;
+    auth_user_request_t *auth_user_request;
 /* XXX combine two authuser structs. Incomplete: it should merge in hash references 
-   too and ask the module to merge in scheme data*/
-    debug (29,5) ("authenticateAuthUserMerge auth_user '%d' into auth_user '%d'.\n",from,to);
+ * too and ask the module to merge in scheme data */
+    debug(29, 5) ("authenticateAuthUserMerge auth_user '%d' into auth_user '%d'.\n", from, to);
     link = from->requests.head;
-    while (link)
-    {
-        auth_user_request=link->data;
-        tmplink=link;
-        link=link->next;
-        dlinkDelete(tmplink, &from->requests);
-        dlinkAddTail(auth_user_request, tmplink, &to->requests);
-        auth_user_request->auth_user=to;
+    while (link) {
+	auth_user_request = link->data;
+	tmplink = link;
+	link = link->next;
+	dlinkDelete(tmplink, &from->requests);
+	dlinkAddTail(auth_user_request, tmplink, &to->requests);
+	auth_user_request->auth_user = to;
     }
-    to->references+=from->references;
-    from->references=0;
+    to->references += from->references;
+    from->references = 0;
     authenticateFreeProxyAuthUser(from);
 }
 
@@ -624,69 +632,70 @@
     auth_user_hash_pointer *proxy_auth_hash;
 #endif
     dlink_node *link, *tmplink;
-    assert(data !=NULL);
-    debug(29,5) ("authenticateFreeProxyAuthUser: Freeing auth_user '%d' with refcount '%d'.\n",u,u->references);
-    assert(u->references==0);
+    assert(data != NULL);
+    debug(29, 5) ("authenticateFreeProxyAuthUser: Freeing auth_user '%d' with refcount '%d'.\n", u, u->references);
+    assert(u->references == 0);
     /* were they linked in by username ? */
     if (u->usernamehash) {
-        assert(u->usernamehash->auth_user == u);
-        debug(29,5) ("authenticateFreeProxyAuthUser: removing usernamehash entry '%d'\n",u->usernamehash);
-        hash_remove_link(proxy_auth_username_cache,
-            (hash_link *) u->usernamehash);
-        /* don't free the key as we use the same user string as the auth_user 
-         * structure */
-        memFree(u->usernamehash, MEM_AUTH_USER_HASH);
+	assert(u->usernamehash->auth_user == u);
+	debug(29, 5) ("authenticateFreeProxyAuthUser: removing usernamehash entry '%d'\n", u->usernamehash);
+	hash_remove_link(proxy_auth_username_cache,
+	    (hash_link *) u->usernamehash);
+	/* don't free the key as we use the same user string as the auth_user 
+	 * structure */
+	memFree(u->usernamehash, MEM_AUTH_USER_HASH);
     }
 #if 0
     /* were they linked in by one or more proxy-authenticate headers */
     link = u->proxy_auth_list.head;
     while (link) {
-        debug(29,6) ("authenticateFreeProxyAuthUser: removing proxy_auth hash entry '%d'\n",link->data);
-        proxy_auth_hash = link->data;
-        tmplink=link;
-        link=link->next;
-        dlinkDelete(tmplink, &u->proxy_auth_list);
-        hash_remove_link(proxy_auth_cache, (hash_link *) proxy_auth_hash);
-        /* free the key (usually the proxy_auth header) */
-        xfree(proxy_auth_hash->key);
-        memFree(proxy_auth_hash, MEM_AUTH_USER_HASH);
+	debug(29, 6) ("authenticateFreeProxyAuthUser: removing proxy_auth hash entry '%d'\n", link->data);
+	proxy_auth_hash = link->data;
+	tmplink = link;
+	link = link->next;
+	dlinkDelete(tmplink, &u->proxy_auth_list);
+	hash_remove_link(proxy_auth_cache, (hash_link *) proxy_auth_hash);
+	/* free the key (usually the proxy_auth header) */
+	xfree(proxy_auth_hash->key);
+	memFree(proxy_auth_hash, MEM_AUTH_USER_HASH);
     }
 #endif
     /* remove any outstanding requests */
     link = u->requests.head;
     while (link) {
-        debug(29,5) ("authenticateFreeProxyAuthUser: removing request entry '%d'\n",link->data);
-        auth_user_request = link->data;
-        tmplink = link;
-        link=link->next;
-        dlinkDelete(tmplink, &u->requests);
-        dlinkNodeDelete(tmplink);
-        authenticateAuthUserRequestFree(auth_user_request);
+	debug(29, 5) ("authenticateFreeProxyAuthUser: removing request entry '%d'\n", link->data);
+	auth_user_request = link->data;
+	tmplink = link;
+	link = link->next;
+	dlinkDelete(tmplink, &u->requests);
+	dlinkNodeDelete(tmplink);
+	authenticateAuthUserRequestFree(auth_user_request);
     }
     /* free cached acl results */
     aclCacheMatchFlush(&u->proxy_match_cache);
-    if (u->scheme_data && u->auth_module>0)
-        authscheme_list[u->auth_module-1].FreeUser(u);
+    if (u->scheme_data && u->auth_module > 0)
+	authscheme_list[u->auth_module - 1].FreeUser(u);
     /* prevent accidental reuse */
-    u->auth_type=AUTH_UNKNOWN;
+    u->auth_type = AUTH_UNKNOWN;
     memFree(u, MEM_AUTH_USER_T);
 }
 
 void
-authenticateInitUserCache(){
+authenticateInitUserCache()
+{
     if (!proxy_auth_username_cache) {
-        /* First time around, 7921 should be big enough */
-        proxy_auth_username_cache =
-            hash_create((HASHCMP *) strcmp, 7921, hash_string);
-        assert(proxy_auth_username_cache);
-#if 0
-        /* First time around, 7921 should be big enough */
-        proxy_auth_cache =
-            hash_create((HASHCMP *) strcmp, 7921, hash_string);
-        assert(proxy_auth_cache);
+	/* First time around, 7921 should be big enough */
+	proxy_auth_username_cache =
+	    hash_create((HASHCMP *) strcmp, 7921, hash_string);
+	assert(proxy_auth_username_cache);
+#if 0
+	/* First time around, 7921 should be big enough */
+	proxy_auth_cache =
+	    hash_create((HASHCMP *) strcmp, 7921, hash_string);
+	assert(proxy_auth_cache);
 #endif
-        eventAdd("User Cache Maintenance", authenticateProxyUserCacheCleanup, NULL, Config.authenticateGCInterval, 1);
-        }
+	eventAdd("User Cache Maintenance", authenticateProxyUserCacheCleanup, NULL, Config.authenticateGCInterval, 1);
+    }
 }
 
 void
@@ -699,27 +708,27 @@
      */
     auth_user_hash_pointer *usernamehash;
     auth_user_t *auth_user;
-    char * username=NULL;
-    debug(29,3) ("authenticateProxyUserCacheCleanup: Cleaning the user cache now\n");
-    debug(29,3) ("authenticateProxyUserCacheCleanup: Current time: %d\n", current_time.tv_sec);
+    char *username = NULL;
+    debug(29, 3) ("authenticateProxyUserCacheCleanup: Cleaning the user cache now\n");
+    debug(29, 3) ("authenticateProxyUserCacheCleanup: Current time: %d\n", current_time.tv_sec);
     hash_first(proxy_auth_username_cache);
-    while ((usernamehash=((auth_user_hash_pointer *)hash_next(proxy_auth_username_cache)))) {
-        auth_user=usernamehash->auth_user;
-        username=authenticateUserUsername(auth_user);
-
-        /* if we need to have inpedendent expiry clauses, insert a module call
-         * here */
-        debug(29,4) ("authenticateProxyUserCacheCleanup: Cache entry:\n\tType: %d\n\tUsername: %s\n\texpires: %d\n\treferences: %d\n", auth_user->auth_type, username, auth_user->expiretime+ Config.authenticateTTL,auth_user->references);
-        if (auth_user->expiretime + Config.authenticateTTL <= current_time.tv_sec) {
-            debug(29,5)("authenticateProxyUserCacheCleanup: Removing user %s from cache due to timeout.\n",username);
-            /* the minus 1 accounts for the cache lock */
-            if ((authenticateAuthUserInuse(auth_user)-1))
-                debug(29,4)("authenticateProxyUserCacheCleanup: this cache entry has expired AND has a non-zero ref count.\n");
-            else
-                authenticateAuthUserUnlock(auth_user);
-        }
+    while ((usernamehash = ((auth_user_hash_pointer *) hash_next(proxy_auth_username_cache)))) {
+	auth_user = usernamehash->auth_user;
+	username = authenticateUserUsername(auth_user);
+
+	/* if we need to have inpedendent expiry clauses, insert a module call
+	 * here */
+	debug(29, 4) ("authenticateProxyUserCacheCleanup: Cache entry:\n\tType: %d\n\tUsername: %s\n\texpires: %d\n\treferences: %d\n", auth_user->auth_type, username, auth_user->expiretime + Config.authenticateTTL, auth_user->references);
+	if (auth_user->expiretime + Config.authenticateTTL <= current_time.tv_sec) {
+	    debug(29, 5) ("authenticateProxyUserCacheCleanup: Removing user %s from cache due to timeout.\n", username);
+	    /* the minus 1 accounts for the cache lock */
+	    if ((authenticateAuthUserInuse(auth_user) - 1))
+		debug(29, 4) ("authenticateProxyUserCacheCleanup: this cache entry has expired AND has a non-zero ref count.\n");
+	    else
+		authenticateAuthUserUnlock(auth_user);
+	}
     }
-    debug(29,3) ("authenticateProxyUserCacheCleanup: Finished cleaning the user cache.\n");
+    debug(29, 3) ("authenticateProxyUserCacheCleanup: Finished cleaning the user cache.\n");
     eventAdd("User Cache Maintenance", authenticateProxyUserCacheCleanup, NULL, Config.authenticateGCInterval, 1);
 }
 
@@ -729,17 +738,18 @@
  */
 
 void
-authenticateUserCacheRestart(){
+authenticateUserCacheRestart()
+{
     auth_user_hash_pointer *usernamehash;
     auth_user_t *auth_user;
-    char * username=NULL;
-    debug(29,3) ("authenticateUserCacheRestart: Clearing config dependent cache data.\n");
+    char *username = NULL;
+    debug(29, 3) ("authenticateUserCacheRestart: Clearing config dependent cache data.\n");
     hash_first(proxy_auth_username_cache);
-    while ((usernamehash=((auth_user_hash_pointer *)hash_next(proxy_auth_username_cache)))) {
-        auth_user=usernamehash->auth_user;
-        username=authenticateUserUsername(auth_user);
-        debug(29,5) ("authenticateUserCacheRestat: Clearing cache ACL results for user: %s\n", username);
-        aclCacheMatchFlush(&auth_user->proxy_match_cache);
+    while ((usernamehash = ((auth_user_hash_pointer *) hash_next(proxy_auth_username_cache)))) {
+	auth_user = usernamehash->auth_user;
+	username = authenticateUserUsername(auth_user);
+	debug(29, 5) ("authenticateUserCacheRestat: Clearing cache ACL results for user: %s\n", username);
+	aclCacheMatchFlush(&auth_user->proxy_match_cache);
     }
 
 }
@@ -747,16 +757,18 @@
 
 #if 0
 void
-authenticateProxyAuthCacheAddLink(const char *key, auth_user_t *auth_user){
+authenticateProxyAuthCacheAddLink(const char *key, auth_user_t * auth_user)
+{
     auth_user_hash_pointer *proxy_auth_hash;
     proxy_auth_hash =
-        memAllocate(MEM_AUTH_USER_HASH);
+	memAllocate(MEM_AUTH_USER_HASH);
     proxy_auth_hash->key = xstrdup(key);
     proxy_auth_hash->auth_user = auth_user;
     dlinkAddTail(proxy_auth_hash, &proxy_auth_hash->link,
-        &proxy_auth_hash->auth_user->proxy_auth_list);
+	&proxy_auth_hash->auth_user->proxy_auth_list);
     hash_join(proxy_auth_cache, (hash_link *) proxy_auth_hash);
 }
+
 #endif
 
 /*
@@ -768,7 +780,7 @@
     int i;
     /* find the number of currently known authscheme types */
     for (i = 0; authscheme_list && authscheme_list[i].typestr; i++) {
-        assert(strcmp(authscheme_list[i].typestr, type) != 0);
+	assert(strcmp(authscheme_list[i].typestr, type) != 0);
     }
     /* add the new type */
     authscheme_list = xrealloc(authscheme_list, (i + 2) * sizeof(authscheme_entry_t));
@@ -780,9 +792,10 @@
 
 
 
-/* UserNameCacheAdd: add a auth_user structure to the username cache */ 
+/* UserNameCacheAdd: add a auth_user structure to the username cache */
 void
-authenticateUserNameCacheAdd(auth_user_t *auth_user){
+authenticateUserNameCacheAdd(auth_user_t * auth_user)
+{
     auth_user_hash_pointer *usernamehash;
     usernamehash = memAllocate(MEM_AUTH_USER_HASH);
     usernamehash->key = authenticateUserUsername(auth_user);
@@ -805,34 +818,34 @@
 int
 authenticateCheckAuthUserIP(struct in_addr request_src_addr, auth_user_request_t * auth_user_request)
 {
-    char *username=NULL;
-    if (request_src_addr.s_addr == auth_user_request->auth_user->ipaddr.s_addr || auth_user_request->auth_user->ip_expiretime+ Config.authenticateIpTTL <= squid_curtime) {
-        /* user has not moved ip or had the ip timeout expire */
-        if ((auth_user_request->auth_user->auth_type==AUTH_UNKNOWN) ||
-            (auth_user_request->auth_user->auth_type==AUTH_BROKEN)) {
-            debug(29, 1)
-                ("authenticateCheckProxyAuthIP: broken or unknown auth type %d.\n", auth_user_request->auth_user->auth_type);
-            return 0;
-        }
-        username=authenticateUserRequestUsername(auth_user_request);
-        /* Update IP ttl */
-        auth_user_request->auth_user->ip_expiretime = squid_curtime;
-        auth_user_request->auth_user->ipaddr = request_src_addr;
-        return 1;
+    char *username = NULL;
+    if (request_src_addr.s_addr == auth_user_request->auth_user->ipaddr.s_addr || auth_user_request->auth_user->ip_expiretime + Config.authenticateIpTTL <= squid_curtime) {
+	/* user has not moved ip or had the ip timeout expire */
+	if ((auth_user_request->auth_user->auth_type == AUTH_UNKNOWN) ||
+	    (auth_user_request->auth_user->auth_type == AUTH_BROKEN)) {
+	    debug(29, 1)
+		("authenticateCheckProxyAuthIP: broken or unknown auth type %d.\n", auth_user_request->auth_user->auth_type);
+	    return 0;
+	}
+	username = authenticateUserRequestUsername(auth_user_request);
+	/* Update IP ttl */
+	auth_user_request->auth_user->ip_expiretime = squid_curtime;
+	auth_user_request->auth_user->ipaddr = request_src_addr;
+	return 1;
     }
     /* we are missing a check: expired IP time is actually ok. let it through
      * and update. */
     else {
-        if (Config.onoff.authenticateIpTTLStrict) {
-            /* Access from some other IP address than the one owning
-             * this user ID. Deny access
-             */
+	if (Config.onoff.authenticateIpTTLStrict) {
+	    /* Access from some other IP address than the one owning
+	     * this user ID. Deny access
+	     */
 /*          debug(29, 1)("aclMatchProxyAuth: user '%s' tries to use multiple IP
-addresses ! \n ", username); */
-            return 0;
-        } else {
-            return 1; /* config.onoff.authenticateTTLStrict */
-        }
+ * addresses ! \n ", username); */
+	    return 0;
+	} else {
+	    return 1;		/* config.onoff.authenticateTTLStrict */
+	}
 /* the logic below is bad: if a user logs in twice we will be forcing an
  * external check on the username/password every single time. If a replay
  * attack is being used we will still allow the user through though: so why
@@ -840,18 +853,18 @@
  * prevent users being at more than one location, consider the TTL strict option
  */
 /* with the separate keys for auth lookups, we could add the ip to the key and t
-hen allow users on different ips to be cached and handled separately. */
+ * hen allow users on different ips to be cached and handled separately. */
 //                  else {
-//                      /* user has switched to another IP addr */
-//                      debug(29, 1)
-//                          ("aclMatchProxyAuth: user '%s' has changed IP address \n ",
-//                          user);
-//                      /* remove this user from the hash, making him unknown */
-//                      hash_remove_link(proxy_auth_cache,
-//                          (hash_link *) auth_user);
-//                      aclFreeProxyAuthUser(auth_user);
-//                      /* require the user to reauthenticate */
-//                      return -2;
-//                  }
+	//                      /* user has switched to another IP addr */
+	//                      debug(29, 1)
+	//                          ("aclMatchProxyAuth: user '%s' has changed IP address \n ",
+	//                          user);
+	//                      /* remove this user from the hash, making him unknown */
+	//                      hash_remove_link(proxy_auth_cache,
+	//                          (hash_link *) auth_user);
+	//                      aclFreeProxyAuthUser(auth_user);
+	//                      /* require the user to reauthenticate */
+	//                      return -2;
+	//                  }
     }
 }
